/*============================================================================

                  EduKit84 Example : Display

 Compiler/IDE : PICC-Lite and IDEA

 Processor : PIC16F84A
 Clock : XT 3.2768 MHz


============================================================================*/


/*============================================================================

       INCLUDE

============================================================================*/
#include <pic.h>


/*============================================================================

       Configuration Bits

============================================================================*/
__CONFIG(UNPROTECT & PWRTEN & WDTDIS & XT); 


/*============================================================================

       User definition

============================================================================*/

char segment[8] = {0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80}; /*12345678*/

unsigned char buttons @ (unsigned char)&PORTB;


/*============================================================================

       Program

============================================================================*/

int main(void)
{
  unsigned char i;
  unsigned char temp;

  PORTB=0xFF;
  PORTA=0xFF;
  TRISA=0xFE;

  for(;;) {
    TRISB=0xFF;      /* PORTB input */
    PORTA=0xFF;
    asm("nop");      /*need to wait before reading to have the right value*/
    asm("nop");
    temp=buttons;
    TRISB=0x00;
    PORTA=0xFE;

    for(i=0;i<8;i++) {
      if (!(temp&1)) {
        PORTB=segment[i];    /*show i+1 on the right display*/
        break; 
      }
      temp>>=1;
    }

    if (i==8) PORTB=0xFF;
  }
}
